<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIGL: /home/mohamed/code/tigl/src/standard/containers/tiglMessage_implementation.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIGL
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Macros</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_bc49a3b403b59ab508217f3692053f91.html">standard</a></li><li class="navelem"><a class="el" href="dir_d05ffc96d6688851d72c9652597fc688.html">containers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglMessage_implementation.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * tiglMessage_implementation.hpp</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Dec 5, 2014</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: root</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef TIGLMESSAGE_IMPLEMENTATION_HPP_</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define TIGLMESSAGE_IMPLEMENTATION_HPP_</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglMessage_8hpp.html">tiglAPIMessage.hpp</a>&quot;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">// constructor/destructor</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<a class="code" href="classMessage.html">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<a class="code" href="classMessage.html">Message</a>()</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;{</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;}</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment">// @brief constructor of a message with all fields</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment">// @param tx  the sender vertex</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment">// @param rx  the receiver vertex</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment">// @param messContent  the message body</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<a class="code" href="classMessage.html">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classMessage.html#a607c353c056c6359ab048b7bdb8ec9ba">   33</a></span>&#160;<a class="code" href="classMessage.html">Message</a>(ID_TYPE &amp; tx, ID_TYPE &amp; rx, DATA_TYPE &amp; messContent)</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;{</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    setMessage(tx, rx, messContent);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;}</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<a class="code" href="classMessage.html">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<a class="code" href="classMessage.html">~Message</a>()</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;{</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;}</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment">//@brief returns the sender vertex</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="keyword">inline</span> ID_TYPE &amp; <a class="code" href="classMessage.html#ac9e7b0ec82d4c408ced91f34e44b3e8d">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="classMessage.html#ac9e7b0ec82d4c408ced91f34e44b3e8d">   46</a></span>&#160;<a class="code" href="classMessage.html#ac9e7b0ec82d4c408ced91f34e44b3e8d">getSender</a>()</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;{</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordflow">return</span> sender;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;}</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="comment">//@brief returns the destination vertex</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="keyword">inline</span> ID_TYPE &amp; <a class="code" href="classMessage.html#ac8f4ffba278ab0e5d29820dc82872d6a">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="classMessage.html#ac8f4ffba278ab0e5d29820dc82872d6a">   55</a></span>&#160;<a class="code" href="classMessage.html#ac8f4ffba278ab0e5d29820dc82872d6a"> getRcvr</a>()</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;{</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordflow">return</span> rcvr;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;}</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment">//@breif returns the message content</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keyword">inline</span> DATA_TYPE &amp; <a class="code" href="classMessage.html#a57f18c305ece6cd53c0c02e08309a546">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="classMessage.html#a57f18c305ece6cd53c0c02e08309a546">   63</a></span>&#160;<a class="code" href="classMessage.html#a57f18c305ece6cd53c0c02e08309a546">getContent</a>()</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;{</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordflow">return</span> content;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;}</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="comment">//@brief preparing the full message fields</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="comment">// @param tx  the sender vertex</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="comment">// @param rx  the receiver vertex</span></div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment">// @param messContent  the message body</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classMessage.html#a03cd1893fc75256c319cba7d850f0dcd">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="classMessage.html#a03cd1893fc75256c319cba7d850f0dcd">   74</a></span>&#160;<a class="code" href="classMessage.html#a03cd1893fc75256c319cba7d850f0dcd">setMessage</a>(ID_TYPE &amp; tx, ID_TYPE &amp; rx, DATA_TYPE &amp; messContent)</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;{</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    sender = tx;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    rcvr = rx;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    content = messContent;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;}</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="comment">//@brief copy from another message</span></div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="comment">// @param newMessage  reference to the other messages</span></div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> CMessages&gt;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="keyword">inline</span>  <span class="keywordtype">void</span>  <a class="code" href="classMessage.html#a03cd1893fc75256c319cba7d850f0dcd">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="classMessage.html#a38c93c3a1da92bd20e0a8f166c30b6b7">   87</a></span>&#160;<a class="code" href="classMessage.html#a03cd1893fc75256c319cba7d850f0dcd">setMessage</a>(CMessages &amp; newMessage)</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;{</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    content = newMessage.getContent();</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    rcvr = newMessage.getRcvr();</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    sender = newMessage.getSender();</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;}</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="comment">//@brief set the message content</span></div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="comment">// @param newContent  the new message content</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classMessage.html#ab7355583d37391bd699f3fca47073281">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="classMessage.html#ab7355583d37391bd699f3fca47073281">   99</a></span>&#160;<a class="code" href="classMessage.html#ab7355583d37391bd699f3fca47073281">setContent</a>(DATA_TYPE &amp; newContent)</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;{</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    content = newContent;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;}</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="comment">//@brief sum new content to the current message content</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="comment">// @param newContent  the new message content (to be summed with the current message value)</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classMessage.html#a3ddf04f2e6372501e0077170387d1723">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="classMessage.html#a3ddf04f2e6372501e0077170387d1723">  108</a></span>&#160;<a class="code" href="classMessage.html#a3ddf04f2e6372501e0077170387d1723">sumContent</a>(DATA_TYPE &amp; newContent)</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;{</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    content += newContent;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;}</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="comment">//@brief copy a new message content if its value is bigger than the current message content</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="comment">//@param newMessage  reference to the other messages</span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> CMessages&gt;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="keyword">inline</span>  <span class="keywordtype">void</span>  <a class="code" href="classMessage.html#a436d435e1a8bac5f8e127c3e1f164623">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00118"></a><span class="lineno"><a class="line" href="classMessage.html#a436d435e1a8bac5f8e127c3e1f164623">  118</a></span>&#160;<a class="code" href="classMessage.html#a436d435e1a8bac5f8e127c3e1f164623">maxContent</a>(CMessages &amp; newMessage)</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;{</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    DATA_TYPE newContent = newMessage.getContent();</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="keywordflow">if</span>(newContent &gt; content )</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    {</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        content = newContent;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        sender = newMessage.getSender();</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    }</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;}</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="comment">//@brief copy a new message content if its value is smaller than the current message content</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="comment">//@param newMessage  reference to the other messages</span></div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> CMessages&gt;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="keyword">inline</span>  <span class="keywordtype">void</span>  <a class="code" href="classMessage.html#a6356c7503304f26b38f819f64b10fbbb">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00133"></a><span class="lineno"><a class="line" href="classMessage.html#a6356c7503304f26b38f819f64b10fbbb">  133</a></span>&#160;<a class="code" href="classMessage.html#a6356c7503304f26b38f819f64b10fbbb">minContent</a>(CMessages &amp; newMessage)</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;{</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    DATA_TYPE newContent = newMessage.getContent();</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="keywordflow">if</span>(newContent &lt; content)</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    {</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        content = newContent;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        sender = newMessage.getSender();</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    }</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;}</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="comment">//@brief pack the content of the message to a uint8_t buffer. It is organized as : rcvr, sender, content</span></div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="comment">//@param buf  a uint8_t buffer that will have the packed message</span></div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;<span class="comment">//@retval the size of the packed message in bytes.</span></div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="keyword">inline</span> uint_fast32_t <a class="code" href="classMessage.html#a357e66838738d2e656066406920a0262">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00149"></a><span class="lineno"><a class="line" href="classMessage.html#a357e66838738d2e656066406920a0262">  149</a></span>&#160;<a class="code" href="classMessage.html#a357e66838738d2e656066406920a0262">pack</a>(uint8_t *buf)</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;{</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="comment">//      *(buf++) = 0; // data message flag</span></div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    memcpy(buf, &amp;rcvr, <span class="keyword">sizeof</span>(ID_TYPE));</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    buf += <span class="keyword">sizeof</span>(ID_TYPE);</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    memcpy(buf, &amp;sender, <span class="keyword">sizeof</span>(ID_TYPE));</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    buf += <span class="keyword">sizeof</span>(ID_TYPE);</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    memcpy(buf, &amp;content, <span class="keyword">sizeof</span>(DATA_TYPE));</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <span class="keywordflow">return</span> 2*<span class="keyword">sizeof</span>(ID_TYPE)+<span class="keyword">sizeof</span>(DATA_TYPE);</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;}</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;<span class="comment">//@brief unpack a packed message to get the message</span></div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="comment">//@param buf  a uint8_t buffer that has the packed message</span></div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;<span class="comment">//@retval the size of the packed message in bytes.</span></div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;<span class="keyword">inline</span> uint_fast32_t <a class="code" href="classMessage.html#ae23c04781f95e7c740d89861ebbca56d">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00166"></a><span class="lineno"><a class="line" href="classMessage.html#ae23c04781f95e7c740d89861ebbca56d">  166</a></span>&#160;<a class="code" href="classMessage.html#ae23c04781f95e7c740d89861ebbca56d">unpack</a>(uint8_t *buf)</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;{</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="comment">//      if(*buf)</span></div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="comment">//          return 0; // first uint8_t should always be zero</span></div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;<span class="comment">//      buf++;</span></div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    memcpy(&amp;rcvr, buf, <span class="keyword">sizeof</span>(ID_TYPE));</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    buf += <span class="keyword">sizeof</span>(ID_TYPE);</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    memcpy(&amp;sender, buf, <span class="keyword">sizeof</span>(ID_TYPE));</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    buf += <span class="keyword">sizeof</span>(ID_TYPE);</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    memcpy(&amp;content, buf, <span class="keyword">sizeof</span>(DATA_TYPE));</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    <span class="keywordflow">return</span> 2*<span class="keyword">sizeof</span>(ID_TYPE)+<span class="keyword">sizeof</span>(DATA_TYPE);</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;}</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;<span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;<span class="comment"></span><span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;<span class="keyword">inline</span> uint_fast32_t <a class="code" href="classMessage.html#a2ed0c8d3abb07af98fd67362fffaacec">Message&lt;DATA_TYPE, ID_TYPE&gt;::</a></div>
<div class="line"><a name="l00183"></a><span class="lineno"><a class="line" href="classMessage.html#a2ed0c8d3abb07af98fd67362fffaacec">  183</a></span>&#160;<a class="code" href="classMessage.html#a2ed0c8d3abb07af98fd67362fffaacec">sizeInBytes</a>()</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;{</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <span class="keywordflow">return</span> 2*<span class="keyword">sizeof</span>(ID_TYPE)+<span class="keyword">sizeof</span>(DATA_TYPE);</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;}</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="comment">//====================================================================================================</span></div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;<span class="keyword">typedef</span> <a class="code" href="classMessage.html">Message&lt;double, uint_fast32_t&gt;</a> <a class="code" href="classMessage.html">DblMessage</a>;</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGLMESSAGE_IMPLEMENTATION_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classMessage_html"><div class="ttname"><a href="classMessage.html">Message</a></div><div class="ttdoc">core data message class definition It handles all the data message fields and processing It is a temp...</div><div class="ttdef"><b>Definition:</b> tiglAPIMessage.hpp:30</div></div>
<div class="ttc" id="classMessage_html_a436d435e1a8bac5f8e127c3e1f164623"><div class="ttname"><a href="classMessage.html#a436d435e1a8bac5f8e127c3e1f164623">Message::maxContent</a></div><div class="ttdeci">void maxContent(CMessages &amp;newMessage)</div><div class="ttdoc">copy a new message content if its value is bigger than the current message content ...</div><div class="ttdef"><b>Definition:</b> tiglMessage_implementation.hpp:118</div></div>
<div class="ttc" id="classMessage_html_ac9e7b0ec82d4c408ced91f34e44b3e8d"><div class="ttname"><a href="classMessage.html#ac9e7b0ec82d4c408ced91f34e44b3e8d">Message::getSender</a></div><div class="ttdeci">ID_TYPE &amp; getSender()</div><div class="ttdoc">returns the sender vertex </div><div class="ttdef"><b>Definition:</b> tiglMessage_implementation.hpp:46</div></div>
<div class="ttc" id="classMessage_html_ae23c04781f95e7c740d89861ebbca56d"><div class="ttname"><a href="classMessage.html#ae23c04781f95e7c740d89861ebbca56d">Message::unpack</a></div><div class="ttdeci">uint_fast32_t unpack(uint8_t *buf)</div><div class="ttdoc">unpack a packed message to get the message </div><div class="ttdef"><b>Definition:</b> tiglMessage_implementation.hpp:166</div></div>
<div class="ttc" id="classMessage_html_a357e66838738d2e656066406920a0262"><div class="ttname"><a href="classMessage.html#a357e66838738d2e656066406920a0262">Message::pack</a></div><div class="ttdeci">uint_fast32_t pack(uint8_t *buf)</div><div class="ttdoc">pack the content of the message to a uint8_t buffer. It is organized as : rcvr, sender, content </div><div class="ttdef"><b>Definition:</b> tiglMessage_implementation.hpp:149</div></div>
<div class="ttc" id="classMessage_html_a57f18c305ece6cd53c0c02e08309a546"><div class="ttname"><a href="classMessage.html#a57f18c305ece6cd53c0c02e08309a546">Message::getContent</a></div><div class="ttdeci">DATA_TYPE &amp; getContent()</div><div class="ttdoc">returns the message content </div><div class="ttdef"><b>Definition:</b> tiglMessage_implementation.hpp:63</div></div>
<div class="ttc" id="classMessage_html_a2ed0c8d3abb07af98fd67362fffaacec"><div class="ttname"><a href="classMessage.html#a2ed0c8d3abb07af98fd67362fffaacec">Message::sizeInBytes</a></div><div class="ttdeci">uint_fast32_t sizeInBytes()</div><div class="ttdoc">returns message size in bytes </div><div class="ttdef"><b>Definition:</b> tiglMessage_implementation.hpp:183</div></div>
<div class="ttc" id="classMessage_html_a3ddf04f2e6372501e0077170387d1723"><div class="ttname"><a href="classMessage.html#a3ddf04f2e6372501e0077170387d1723">Message::sumContent</a></div><div class="ttdeci">void sumContent(DATA_TYPE &amp;newContent)</div><div class="ttdoc">sum new content to the current message content </div><div class="ttdef"><b>Definition:</b> tiglMessage_implementation.hpp:108</div></div>
<div class="ttc" id="tiglMessage_8hpp_html"><div class="ttname"><a href="tiglMessage_8hpp.html">tiglAPIMessage.hpp</a></div><div class="ttdoc">contains core Massage container class for tigl </div></div>
<div class="ttc" id="classMessage_html_a6356c7503304f26b38f819f64b10fbbb"><div class="ttname"><a href="classMessage.html#a6356c7503304f26b38f819f64b10fbbb">Message::minContent</a></div><div class="ttdeci">void minContent(CMessages &amp;newMessage)</div><div class="ttdoc">copy a new message content if its value is smaller than the current message content ...</div><div class="ttdef"><b>Definition:</b> tiglMessage_implementation.hpp:133</div></div>
<div class="ttc" id="classMessage_html_ab7355583d37391bd699f3fca47073281"><div class="ttname"><a href="classMessage.html#ab7355583d37391bd699f3fca47073281">Message::setContent</a></div><div class="ttdeci">void setContent(DATA_TYPE &amp;newContent)</div><div class="ttdoc">set the message content </div><div class="ttdef"><b>Definition:</b> tiglMessage_implementation.hpp:99</div></div>
<div class="ttc" id="classMessage_html_a03cd1893fc75256c319cba7d850f0dcd"><div class="ttname"><a href="classMessage.html#a03cd1893fc75256c319cba7d850f0dcd">Message::setMessage</a></div><div class="ttdeci">void setMessage(ID_TYPE &amp;tx, ID_TYPE &amp;rx, DATA_TYPE &amp;messContent)</div><div class="ttdoc">preparing the full message fields </div><div class="ttdef"><b>Definition:</b> tiglMessage_implementation.hpp:74</div></div>
<div class="ttc" id="classMessage_html_ac8f4ffba278ab0e5d29820dc82872d6a"><div class="ttname"><a href="classMessage.html#ac8f4ffba278ab0e5d29820dc82872d6a">Message::getRcvr</a></div><div class="ttdeci">ID_TYPE &amp; getRcvr()</div><div class="ttdoc">returns the destination vertex </div><div class="ttdef"><b>Definition:</b> tiglMessage_implementation.hpp:55</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Mon Jan 19 2015 12:23:47 for TIGL by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
